<template>
  <div class="q-pb-md">
    <div
      class="flex items-center"
      v-if="isLoadingMenuItems"
    >
      <q-spinner name="mat" size="32px"/>
      <span class="q-ml-sm">Loading menu...</span>
    </div>
    <div v-else>
      <div class="q-mb-md text-right">
        <q-btn
          color="green"
          label="Add item"
          @click="add(null)"
        />
      </div>
      <draggable
        v-model="order[null]"
        handle=".menu-item__drag-handle"
        class="q-list"
        @change="info => changeOrder(null, info)"
      >
        <menu-item
          v-for="item in order[null]"
          :key="item"
          :index="item"
          :items="items"
          :edit="edit"
          :remove="remove"
          :add="add"
          :order="order"
          :change-order="changeOrder"
        />
      </draggable>
    </div>
    <menu-item-editor
      :is-active="isMenuEditorActive"
      :item="editingItem"
      :has-children="(editingItem && !!order[editingItem.id]) || false"
      @close="closeMenuEditor"
      @saved="loadMenu"
    />
  </div>
</template>

<script>
    import QSpinner from 'quasar-framework/src/components/spinner/QSpinner';
    import MenuItem from './menuItem';
    import MenuItemEditor from './menuItemEditor';
    import endpointsMixin from '../../../../mixins/endpointsMixin';
    import { defaultMenuItem } from '../../../../utilities/migrateConfig';

    export default {
      name: 'menuConfigurator',
      components: { MenuItemEditor, QSpinner, MenuItem },
      mixins: [endpointsMixin],
      data() {
        return {
          items: [],
          order: {},

          isMenuEditorActive: false,
          editingItem: null,
          isLoadingMenuItems: false,
        };
      },
      created() {
        this.loadMenu();
      },
      methods: {
        changeOrder(id) {
          this.$nextTick(() => {
            Promise.all(
              this.order[id]
                .map((itemIndex) => this.items[itemIndex])
                .map((item, index) => new Promise((resolve, reject) => {
                  if (item.order_position !== index) {
                    this.saveMenuItem({
                      ...item,
                      order_position: index,
                    }, false)
                      .then(resolve)
                      .catch(reject);
                  } else {
                    resolve();
                  }
                })),
            )
              .then(() => {
                this.notifyInfo({
                  message: 'Menu has been reordered',
                });

                this.$eventHub.$emit('menuReordered');
              })
              .catch(() => {
                this.notifyError({
                  title: 'Unable to reoder menu',
                });
              });
          });
        },
        closeMenuEditor() {
          this.isMenuEditorActive = false;
          this.editingItem = null;
        },
        edit(index) {
          this.isMenuEditorActive = true;
          this.editingItem = this.items[index];
        },
        remove(index) {
          this.$q.dialog({
            title: 'Remove menu item',
            message: `Are you sure want to remove ${ this.items[index].menu_name } from menu?`,
            cancel: !this.order[this.items[index].id],
            options: this.order[this.items[index].id] ? {
              type: 'radio',
              model: 'no',
              items: this.order[this.items[index].id]
                ? [
                  { label: 'Yes and remove children', value: 'removeChildren' },
                  { label: 'Yes and move children to root level', value: 'moveChildren' },
                  { label: 'No', value: 'no' },
                ] : [
                  { label: 'Yes', value: 'yes' },
                  { label: 'No', value: 'no' },
                ],
            } : null,
          })
            .then((answer) => {
              if (!answer) {
                this.removeMenuItem(this.items[index])
                  .then(() => {
                    this.items.splice(index, 1);

                    const orderIndex = this.order[this.items[index].parent_id].indexOf(this.items[index].id);
                    this.order[this.items[index].parent_id].splice(orderIndex, 1);
                  });
              } else if (['removeChildren', 'yes'].indexOf(answer) > -1) {
                this.removeMenuItem(this.items[index])
                  .then(() => {
                    this.items.splice(index, 1);

                    const orderIndex = this.order[this.items[index].parent_id].indexOf(this.items[index].id);
                    this.order[this.items[index].parent_id].splice(orderIndex, 1);
                  });
                // @TODO Also remove all child tree
              } else if (answer === 'moveChildren') {
                this.items = [...this.items].map((item) => {
                  if (item.parent_id === this.items[index].id) {
                    item.parent_id = null;
                    // eslint-disable-next-line dot-notation
                    item.order_position = this.order[null].length - 1;
                    // eslint-disable-next-line dot-notation
                    this.order[null].push(this.items[index].id);
                  }
                  this.saveMenuItem(item);
                  return item;
                });
                this.items.splice(index, 1);
              }
            })
            .catch(() => {
            });
        },
        add(index = null) {
          this.editingItem = {
            ...defaultMenuItem,
            parent_id: index !== null ? this.items[index].id : null,
            order_position: (this.order[index] || [null]).length - 1,
          };
          this.isMenuEditorActive = true;
        },
        loadMenu() {
          this.isLoadingMenuItems = true;

          this.fetchMenuItems()
            .then((results) => {
              this.items = results;
              this.isLoadingMenuItems = false;

              const order = {};
              results.forEach(({ parent_id: parent, order_position: position }, index) => {
                if (!(parent in order)) {
                  order[parent] = [];
                }
                order[parent].push({
                  index,
                  position,
                });
              });
              Object.entries(order).forEach(([key, children]) => {
                order[key] = children.sort(({ position: a }, { position: b }) => (
                  // eslint-disable-next-line no-nested-ternary
                  a === b ? 0 : (a > b ? 1 : -1)
                )).map(({ index }) => index);
              });

              this.order = order;
            })
            .catch(() => {
              this.isLoadingMenuItems = false;
            });
        },
      },
    };
</script>
